#
# Copyright (C) 2009 - Phyware Chen
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The Rhythmbox authors hereby grant permission for non-GPL compatible
# GStreamer plugins to be used and distributed together with GStreamer
# and Rhythmbox. This permission is above and beyond the permissions granted
# by the GPL license by which Rhythmbox is covered. If you modify this code
# you may extend this exception to your version of the code, but you are not
# obligated to do so. If you do not wish to do so, delete this exception
# statement from your version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.

import os.path
import BaiduLrc

class GetLrc:
	def __init__(self, plugin):	
		self.plugin = plugin
		self.dir = plugin.dir
		self.callback = plugin.lrcGot 	#callback:after having got the lrc,this callback will be called
		self.baiduLrc = BaiduLrc.BaiduLrc(plugin)
	
	def get(self, title, artist, duration):	
		checkFileList = [artist + ' - ' + title + '.lrc', title + '.lrc']
		checkFileList = [item.lower() for item in checkFileList]
		self.plugin.showState("searching locally...")

		for file in os.listdir(self.dir):
			fileTemp = file.lower()
			for item in checkFileList:
				if item == fileTemp and self.callback(os.path.join(self.dir, file)) == True:
					return 

		if artist != 'Unknown' and os.path.exists(os.path.join(self.dir, artist)):
			for file in os.listdir(os.path.join(self.dir, artist)):
				fileTemp = file.lower()
				for item in checkFileList:
					if item == fileTemp and self.callback(os.path.join(self.dir, artist, file)) == True:
						return

		#search online
		self.plugin.showState("searching online...")
		self.baiduLrc.getLrc(title, artist, self.dir)
	
if __name__ == '__main__':
	import sys
	print GetLrc(sys.argv[1]).get(sys.argv[2], sys.argv[3])
