#
# Copyright (C) 2009 - Phyware Chen
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The Rhythmbox authors hereby grant permission for non-GPL compatible
# GStreamer plugins to be used and distributed together with GStreamer
# and Rhythmbox. This permission is above and beyond the permissions granted
# by the GPL license by which Rhythmbox is covered. If you modify this code
# you may extend this exception to your version of the code, but you are not
# obligated to do so. If you do not wish to do so, delete this exception
# statement from your version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.

import re

class ParseConf:
	def __init__(self):
		self.patKeyValue = re.compile(r"^ *(?P<key>\b\w+\b) *= *'(?P<value>[^']+)'")
		self.dict = None
	
	def parseFile(self, fileName):
		list = []
		file = open(fileName, 'r')
		for line in file:
			result = self.patKeyValue.search(line)
			if result != None:
				list.append((result.group('key'), result.group('value')))

		self.dict = dict(list)
	
	def getValue(self, key):
		if not(key in self.dict):
			return None
		return self.dict[key]

if __name__ == '__main__':
	parser = ParseConf()
	file = open('lyricboxen.conf')
	parser.parseFile(file)
