import gtk
import re

class Test:
	def __init__(self):
		window = gtk.Window()
		window.set_default_size(400, 400)
		window.connect('destroy', lambda w:gtk.main_quit())
		vbox = gtk.VBox()
		vbox.set_spacing(6)
		sw = gtk.ScrolledWindow()
		sw.add_with_viewport(vbox)
		window.add(sw)

		file = open('/etc/X11/rgb.txt','r')
		pattern = re.compile(r'^(?P<value>[0-9\s]{11})\s*(?P<name>[a-zA-Z][a-zA-Z0-9 ]*$)')
		valuePrev = None

		for line in file:
			result = pattern.search(line)
			if result == None:
				continue
			value = result.group('value')
			if value == valuePrev:
				continue
			else:
				valuePrev = value

			eventBox = gtk.EventBox()
			label = gtk.Label()
			eventBox.add(label)
			vbox.pack_start(eventBox)
			try:
				eventBox.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse(result.group('name')))
				label.set_text(result.group('name'))
			except:
				label.set_text(result.group('name') + ' :unrecognized')
		
		window.show_all()

if __name__ == '__main__':
	Test()
	gtk.main()
